package vishnu.builder;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.SpringLayout;
import java.io.File;
import vishnu.util.SpringUtilities;

public class IndexerGUI {
    public final static boolean RIGHT_TO_LEFT = false;
    public Toolkit toolkit = Toolkit.getDefaultToolkit();
    private static JTextField[] textFields; 
    private static JTextArea ja;

    public static void addComponentsToPane(Container pane)
    {
	String [] labels = {"Collections directory: ", "Collection id (directory name): ", "Collection name: ","Collection description: ", "Indexer (\"mg\" or \"luc\"): ", "Use views (\"yes\" or \"no\"): "};
        int numPairs = labels.length;
        textFields = new JTextField[numPairs];
	
        pane.setLayout(new BoxLayout(pane,BoxLayout.Y_AXIS));
	
        JPanel p = new JPanel(new SpringLayout());
	
        for (int i = 0; i < numPairs; i++) {
	    JLabel l = new JLabel(labels[i], JLabel.TRAILING);
	    p.add(l);
	    textFields[i] = new JTextField(30);
	    l.setLabelFor(textFields[i]);
	    p.add(textFields[i]);
	}
	
	SpringUtilities.makeCompactGrid(p,numPairs, 2, 6, 6, //initX, initY
                                6, 6);       //xPad, yPad
	
	pane.add(p);
	
	JPanel butPan = new JPanel();
	butPan.setLayout(new BoxLayout(butPan,BoxLayout.X_AXIS));

	Dimension minSize = new Dimension(10, 50);
	Dimension prefSize = new Dimension(10, 50);
	Dimension maxSize = new Dimension(Short.MAX_VALUE, 50);
	butPan.add(new Box.Filler(minSize, prefSize, maxSize));
	
	JButton button = new JButton(" Start indexing ");
        button.setBorder(BorderFactory.createBevelBorder(0));
	button.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){
			build();
                }
            });
        butPan.add(button);

	butPan.add(new Box.Filler(minSize, prefSize, maxSize));
	
        butPan.add(new Box.Filler(minSize, prefSize, maxSize));

	pane.add(butPan);

	butPan.add(new Box.Filler(minSize, prefSize, maxSize));

	ja = new JTextArea(5,5);
        JScrollPane scrollingArea = new JScrollPane(ja);
	scrollingArea.setBorder(BorderFactory.createBevelBorder(1));
	pane.add(scrollingArea);
     }

    private static void build()
    {
	// get data
	String colls_home = textFields[0].getText();
	String coll_id = textFields[1].getText();
	String coll_name = textFields[2].getText();
	String coll_desc = textFields[3].getText();
	String indexer = textFields[4].getText();
	String use_views_str = textFields[5].getText();
	String coll_home = colls_home;
	if (!coll_home.endsWith(File.separator)) {
	    coll_home += File.separator;
	}
	coll_home += coll_id + File.separator;

	if (!indexer.equals("mg") || !indexer.equals("luc")) {
	    indexer = "mg";
	}
	boolean use_views = false;
	if (use_views_str.equals("yes")) {
	    use_views = true;
	}
	String output = "Launching Collection Builder with \n collections home = "+colls_home + "\n collection id = "+coll_name+"\n indexer = "+indexer;
	if (use_views) {
	    output += "\n using views";
	} else {
	    output += "\n not using views";
	}
	ja.setText(output);

	CollectionBuilder builder = new CollectionBuilder(coll_home, coll_id, coll_name, coll_desc, indexer, use_views); 
	output += "\n Indexing Finished";
	ja.setText(output);
    }

    private static void createAndShowGUI() {
        JFrame.setDefaultLookAndFeelDecorated(true);
        JFrame frame = new JFrame("Indexing Tool");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addComponentsToPane(frame.getContentPane());

        frame.pack();

	Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int w = frame.getSize().width;
        int h = frame.getSize().height;
        int x = (dim.width-w)/2;
        int y = (dim.height-h)/2;
        frame.setLocation(x,y);

	frame.setVisible(true);
    }

    public static void main(String[] args) {
	createAndShowGUI();
    }
}
